//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private RPT_PRO[] cacheRPT_PRO = null;

        private static RPT_PRO checkRPT_PRO = new RPT_PRO();

        /// <summary>
        /// Reaction Point Trader Pro (Improved) analizes market structure and behavior. V03.05.15
        /// </summary>
        /// <returns></returns>
        public RPT_PRO RPT_PRO(Color cModerateTextColor, Color cNormalTextColor, Color cPFIColor, Color cProjectionColor, Color cStrongTextColor, Color cWeakTextColor, String my_ID, Boolean newReversal, int overbought, int oversold, PatternFrequency pattern, int plot0width, Boolean popupAlerts, Boolean popupAlertSounds, Boolean sHOWBCOUNT, Boolean showpurpledots, Boolean showReversalInfo, Boolean showReversalPoints, Boolean uSE60PERCENT, Boolean viewTools)
        {
            return RPT_PRO(Input, cModerateTextColor, cNormalTextColor, cPFIColor, cProjectionColor, cStrongTextColor, cWeakTextColor, my_ID, newReversal, overbought, oversold, pattern, plot0width, popupAlerts, popupAlertSounds, sHOWBCOUNT, showpurpledots, showReversalInfo, showReversalPoints, uSE60PERCENT, viewTools);
        }

        /// <summary>
        /// Reaction Point Trader Pro (Improved) analizes market structure and behavior. V03.05.15
        /// </summary>
        /// <returns></returns>
        public RPT_PRO RPT_PRO(Data.IDataSeries input, Color cModerateTextColor, Color cNormalTextColor, Color cPFIColor, Color cProjectionColor, Color cStrongTextColor, Color cWeakTextColor, String my_ID, Boolean newReversal, int overbought, int oversold, PatternFrequency pattern, int plot0width, Boolean popupAlerts, Boolean popupAlertSounds, Boolean sHOWBCOUNT, Boolean showpurpledots, Boolean showReversalInfo, Boolean showReversalPoints, Boolean uSE60PERCENT, Boolean viewTools)
        {
            if (cacheRPT_PRO != null)
                for (int idx = 0; idx < cacheRPT_PRO.Length; idx++)
                    if (cacheRPT_PRO[idx].cModerateTextColor == cModerateTextColor && cacheRPT_PRO[idx].cNormalTextColor == cNormalTextColor && cacheRPT_PRO[idx].cPFIColor == cPFIColor && cacheRPT_PRO[idx].cProjectionColor == cProjectionColor && cacheRPT_PRO[idx].cStrongTextColor == cStrongTextColor && cacheRPT_PRO[idx].cWeakTextColor == cWeakTextColor && cacheRPT_PRO[idx].My_ID == my_ID && cacheRPT_PRO[idx].NewReversal == newReversal && cacheRPT_PRO[idx].Overbought == overbought && cacheRPT_PRO[idx].Oversold == oversold && cacheRPT_PRO[idx].Pattern == pattern && cacheRPT_PRO[idx].plot0width == plot0width && cacheRPT_PRO[idx].PopupAlerts == popupAlerts && cacheRPT_PRO[idx].PopupAlertSounds == popupAlertSounds && cacheRPT_PRO[idx].SHOWBCOUNT == sHOWBCOUNT && cacheRPT_PRO[idx].showpurpledots == showpurpledots && cacheRPT_PRO[idx].ShowReversalInfo == showReversalInfo && cacheRPT_PRO[idx].ShowReversalPoints == showReversalPoints && cacheRPT_PRO[idx].USE60PERCENT == uSE60PERCENT && cacheRPT_PRO[idx].viewTools == viewTools && cacheRPT_PRO[idx].EqualsInput(input))
                        return cacheRPT_PRO[idx];

            lock (checkRPT_PRO)
            {
                checkRPT_PRO.cModerateTextColor = cModerateTextColor;
                cModerateTextColor = checkRPT_PRO.cModerateTextColor;
                checkRPT_PRO.cNormalTextColor = cNormalTextColor;
                cNormalTextColor = checkRPT_PRO.cNormalTextColor;
                checkRPT_PRO.cPFIColor = cPFIColor;
                cPFIColor = checkRPT_PRO.cPFIColor;
                checkRPT_PRO.cProjectionColor = cProjectionColor;
                cProjectionColor = checkRPT_PRO.cProjectionColor;
                checkRPT_PRO.cStrongTextColor = cStrongTextColor;
                cStrongTextColor = checkRPT_PRO.cStrongTextColor;
                checkRPT_PRO.cWeakTextColor = cWeakTextColor;
                cWeakTextColor = checkRPT_PRO.cWeakTextColor;
                checkRPT_PRO.My_ID = my_ID;
                my_ID = checkRPT_PRO.My_ID;
                checkRPT_PRO.NewReversal = newReversal;
                newReversal = checkRPT_PRO.NewReversal;
                checkRPT_PRO.Overbought = overbought;
                overbought = checkRPT_PRO.Overbought;
                checkRPT_PRO.Oversold = oversold;
                oversold = checkRPT_PRO.Oversold;
                checkRPT_PRO.Pattern = pattern;
                pattern = checkRPT_PRO.Pattern;
                checkRPT_PRO.plot0width = plot0width;
                plot0width = checkRPT_PRO.plot0width;
                checkRPT_PRO.PopupAlerts = popupAlerts;
                popupAlerts = checkRPT_PRO.PopupAlerts;
                checkRPT_PRO.PopupAlertSounds = popupAlertSounds;
                popupAlertSounds = checkRPT_PRO.PopupAlertSounds;
                checkRPT_PRO.SHOWBCOUNT = sHOWBCOUNT;
                sHOWBCOUNT = checkRPT_PRO.SHOWBCOUNT;
                checkRPT_PRO.showpurpledots = showpurpledots;
                showpurpledots = checkRPT_PRO.showpurpledots;
                checkRPT_PRO.ShowReversalInfo = showReversalInfo;
                showReversalInfo = checkRPT_PRO.ShowReversalInfo;
                checkRPT_PRO.ShowReversalPoints = showReversalPoints;
                showReversalPoints = checkRPT_PRO.ShowReversalPoints;
                checkRPT_PRO.USE60PERCENT = uSE60PERCENT;
                uSE60PERCENT = checkRPT_PRO.USE60PERCENT;
                checkRPT_PRO.viewTools = viewTools;
                viewTools = checkRPT_PRO.viewTools;

                if (cacheRPT_PRO != null)
                    for (int idx = 0; idx < cacheRPT_PRO.Length; idx++)
                        if (cacheRPT_PRO[idx].cModerateTextColor == cModerateTextColor && cacheRPT_PRO[idx].cNormalTextColor == cNormalTextColor && cacheRPT_PRO[idx].cPFIColor == cPFIColor && cacheRPT_PRO[idx].cProjectionColor == cProjectionColor && cacheRPT_PRO[idx].cStrongTextColor == cStrongTextColor && cacheRPT_PRO[idx].cWeakTextColor == cWeakTextColor && cacheRPT_PRO[idx].My_ID == my_ID && cacheRPT_PRO[idx].NewReversal == newReversal && cacheRPT_PRO[idx].Overbought == overbought && cacheRPT_PRO[idx].Oversold == oversold && cacheRPT_PRO[idx].Pattern == pattern && cacheRPT_PRO[idx].plot0width == plot0width && cacheRPT_PRO[idx].PopupAlerts == popupAlerts && cacheRPT_PRO[idx].PopupAlertSounds == popupAlertSounds && cacheRPT_PRO[idx].SHOWBCOUNT == sHOWBCOUNT && cacheRPT_PRO[idx].showpurpledots == showpurpledots && cacheRPT_PRO[idx].ShowReversalInfo == showReversalInfo && cacheRPT_PRO[idx].ShowReversalPoints == showReversalPoints && cacheRPT_PRO[idx].USE60PERCENT == uSE60PERCENT && cacheRPT_PRO[idx].viewTools == viewTools && cacheRPT_PRO[idx].EqualsInput(input))
                            return cacheRPT_PRO[idx];

                RPT_PRO indicator = new RPT_PRO();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.cModerateTextColor = cModerateTextColor;
                indicator.cNormalTextColor = cNormalTextColor;
                indicator.cPFIColor = cPFIColor;
                indicator.cProjectionColor = cProjectionColor;
                indicator.cStrongTextColor = cStrongTextColor;
                indicator.cWeakTextColor = cWeakTextColor;
                indicator.My_ID = my_ID;
                indicator.NewReversal = newReversal;
                indicator.Overbought = overbought;
                indicator.Oversold = oversold;
                indicator.Pattern = pattern;
                indicator.plot0width = plot0width;
                indicator.PopupAlerts = popupAlerts;
                indicator.PopupAlertSounds = popupAlertSounds;
                indicator.SHOWBCOUNT = sHOWBCOUNT;
                indicator.showpurpledots = showpurpledots;
                indicator.ShowReversalInfo = showReversalInfo;
                indicator.ShowReversalPoints = showReversalPoints;
                indicator.USE60PERCENT = uSE60PERCENT;
                indicator.viewTools = viewTools;
                Indicators.Add(indicator);
                indicator.SetUp();

                RPT_PRO[] tmp = new RPT_PRO[cacheRPT_PRO == null ? 1 : cacheRPT_PRO.Length + 1];
                if (cacheRPT_PRO != null)
                    cacheRPT_PRO.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheRPT_PRO = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Reaction Point Trader Pro (Improved) analizes market structure and behavior. V03.05.15
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.RPT_PRO RPT_PRO(Color cModerateTextColor, Color cNormalTextColor, Color cPFIColor, Color cProjectionColor, Color cStrongTextColor, Color cWeakTextColor, String my_ID, Boolean newReversal, int overbought, int oversold, PatternFrequency pattern, int plot0width, Boolean popupAlerts, Boolean popupAlertSounds, Boolean sHOWBCOUNT, Boolean showpurpledots, Boolean showReversalInfo, Boolean showReversalPoints, Boolean uSE60PERCENT, Boolean viewTools)
        {
            return _indicator.RPT_PRO(Input, cModerateTextColor, cNormalTextColor, cPFIColor, cProjectionColor, cStrongTextColor, cWeakTextColor, my_ID, newReversal, overbought, oversold, pattern, plot0width, popupAlerts, popupAlertSounds, sHOWBCOUNT, showpurpledots, showReversalInfo, showReversalPoints, uSE60PERCENT, viewTools);
        }

        /// <summary>
        /// Reaction Point Trader Pro (Improved) analizes market structure and behavior. V03.05.15
        /// </summary>
        /// <returns></returns>
        public Indicator.RPT_PRO RPT_PRO(Data.IDataSeries input, Color cModerateTextColor, Color cNormalTextColor, Color cPFIColor, Color cProjectionColor, Color cStrongTextColor, Color cWeakTextColor, String my_ID, Boolean newReversal, int overbought, int oversold, PatternFrequency pattern, int plot0width, Boolean popupAlerts, Boolean popupAlertSounds, Boolean sHOWBCOUNT, Boolean showpurpledots, Boolean showReversalInfo, Boolean showReversalPoints, Boolean uSE60PERCENT, Boolean viewTools)
        {
            return _indicator.RPT_PRO(input, cModerateTextColor, cNormalTextColor, cPFIColor, cProjectionColor, cStrongTextColor, cWeakTextColor, my_ID, newReversal, overbought, oversold, pattern, plot0width, popupAlerts, popupAlertSounds, sHOWBCOUNT, showpurpledots, showReversalInfo, showReversalPoints, uSE60PERCENT, viewTools);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Reaction Point Trader Pro (Improved) analizes market structure and behavior. V03.05.15
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.RPT_PRO RPT_PRO(Color cModerateTextColor, Color cNormalTextColor, Color cPFIColor, Color cProjectionColor, Color cStrongTextColor, Color cWeakTextColor, String my_ID, Boolean newReversal, int overbought, int oversold, PatternFrequency pattern, int plot0width, Boolean popupAlerts, Boolean popupAlertSounds, Boolean sHOWBCOUNT, Boolean showpurpledots, Boolean showReversalInfo, Boolean showReversalPoints, Boolean uSE60PERCENT, Boolean viewTools)
        {
            return _indicator.RPT_PRO(Input, cModerateTextColor, cNormalTextColor, cPFIColor, cProjectionColor, cStrongTextColor, cWeakTextColor, my_ID, newReversal, overbought, oversold, pattern, plot0width, popupAlerts, popupAlertSounds, sHOWBCOUNT, showpurpledots, showReversalInfo, showReversalPoints, uSE60PERCENT, viewTools);
        }

        /// <summary>
        /// Reaction Point Trader Pro (Improved) analizes market structure and behavior. V03.05.15
        /// </summary>
        /// <returns></returns>
        public Indicator.RPT_PRO RPT_PRO(Data.IDataSeries input, Color cModerateTextColor, Color cNormalTextColor, Color cPFIColor, Color cProjectionColor, Color cStrongTextColor, Color cWeakTextColor, String my_ID, Boolean newReversal, int overbought, int oversold, PatternFrequency pattern, int plot0width, Boolean popupAlerts, Boolean popupAlertSounds, Boolean sHOWBCOUNT, Boolean showpurpledots, Boolean showReversalInfo, Boolean showReversalPoints, Boolean uSE60PERCENT, Boolean viewTools)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.RPT_PRO(input, cModerateTextColor, cNormalTextColor, cPFIColor, cProjectionColor, cStrongTextColor, cWeakTextColor, my_ID, newReversal, overbought, oversold, pattern, plot0width, popupAlerts, popupAlertSounds, sHOWBCOUNT, showpurpledots, showReversalInfo, showReversalPoints, uSE60PERCENT, viewTools);
        }
    }
}
#endregion
